<html lang="sv">
<head>
    <meta http-equiv="content-type" content="text/html; charset=UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="stylesheet" href="https://lankadedata.se/spec/assets/style.css">
    <title>Specifikation för leverantörsreskontra</title>
</head>
<body class="h-entry">
<div class="head">
    <p><a class="logo" href="https://entryscape.com/">
        <img alt="Logotyp för MetaSolutions AB" src="https://lankadedata.se/spec/assets/metasolutions.png"></a>
    </p>
    <h1 id="title">Specifikation för leverantörsreskontra</h1>
    <h2 id="subtitle">Information om gjorda inköp med belopp, köpare- och leverantörsinformation -
        <time class="dt-updated" datetime="2020-10-09">2020-10-09</time></h2>
    <div>
        <dl>
            <dt>Denna version:</dt>
            <dd><a class="u-url" href="https://lankadedata.se/spec/leverantorsreskontra/1.0">https://lankadedata.se/spec/leverantorsreskontra/1.0</a></dd>
            <dt>Senaste versionen:</dt>
            <dd><a href="https://lankadedata.se/spec/leverantorsreskontra/">https://lankadedata.se/spec/leverantorsreskontra/</a></dd>
            <!--dt>Förra version:</dt>
            <dd><a class="u-url" href="https://lankadedata.se/spec/leverantorsreskontra/1.0">https://lankadedata.se/spec/leverantorsreskontra/1.0</a></dd-->
            <dt class="editor">Författare:</dt>
            <dd class="editor p-author h-card vcard"><a class="p-name fn u-url url"
                                                         href="mailto:eric@metasolutions.se">Eric Hjelmestam</a> - MetaSolutions AB</dd>
            <dd class="editor p-author h-card vcard"><a class="p-name fn u-url url"
                                                         href="mailto:matthias@metasolutions.se">Matthias Palmér</a> - MetaSolutions AB</dd>
            <dd class="editor p-author h-card vcard"><a class="p-name fn u-url url"
                                                        href="mailto:mattias@metasolutions.se">Mathias Axell</a> - MetaSolutions AB</dd>
            <dt>Attribution:</dt>
            <dd>Arbete i Sambruk projekt “REF DATA” <a href="https://sambruk.github.io/Open-Accounts-Payable/">https://sambruk.github.io/Open-Accounts-Payable/</a></dd>
            <dt>Licens:</dt>
            <dd><a href="http://creativecommons.org/licenses/by/4.0/">CC-BY 4.0</a></dd>
        </dl>
    </div>
    <div></div>
    <p class="copyright">Copyright © 2018 <a
            href="https://entryscape.com">MetaSolutions AB</a></p>
    <hr title="Separator for header">
</div>
<nav id="toc">
    <h2>Innehåll</h2>
    <ol class="toc" role="directory">
        <li><a href="#intro"><span class="secno">1</span>Introduktion</a></li>
        <li><a href="#datamodell"><span class="secno">2</span>Datamodell</a></li>
        <li><a href="#csv"><span class="secno">3</span>CSV formatet</a>
            <ol>
                <li><a href="#accessCSV"><span class="secno">3.1</span>Åtkomst via HTTP</a></li>
                <li><a href="#schemaCSV"><span class="secno">3.2</span>Schema</a></li>
            </ol>
        </li>
        <li><a href="#csv"><span class="secno">4</span>JSON formatet</a>
            <ol>
                <li><a href="#accessJSON"><span class="secno">4.1</span>Åtkomst via HTTP</a></li>
                <li><a href="#schemaJSON"><span class="secno">4.2</span>Schema</a></li>
            </ol>
        </li>
        <li><a href="#dcat"><span class="secno">4</span>Beskrivning i datakatalog</a></li>
    </ol>
    <h2>Appendix</h2>
    <ol class="toc">
        <li><a href="#exampleCSV"><span class="secno">A</span>Exempel på inköpsdata i CSV</a></li>
        <li><a href="#exampleJSON"><span class="secno">B</span>Exempel på inköpsdata i JSON</a></li>
        <li><a href="#versions"><span class="secno">C</span>Versionshistorik</a></li>
    </ol>
</nav>

<h2 id="intro">1. Introduktion</h2>
<p>Med leverantörsreskontra menas uppgifter som återfinns om gjorda inköp såsom värde på inköp, leverantörsnamn, inköpande organisation och identifierare till faktura. I texten nedan används för enkelhets skull ordet “ett inköp” för att benämna detta.</p>
<p>Denna specifikation definierar en enkel tabulär informationsmodell för inköp. Specifikationen innefattar också en beskrivning av hur informationen uttrycks i formatet CSV, JSON och länkade data (RDF). Som grund förutsätts CSV kunna levereras då det är praktiskt format och skapar förutsägbarhet för mottagare av informationen.
  Det är också ett format som gör datautdrag enklare då snarlika processer ofta finns.</p>
<p>Uttrycket i länkade data återanvänder konstruktioner från andra initiativ och ger därmed en grund för interoperabilitet med data som uttrycks utan kunskap om denna specifikation.</p>

<h2 id="datamodell">2. Datamodell</h2>
<p>Datamodellen är tabulär, där varje rad motsvarar exakt ett inköp och varje kolumn motsvarar en egenskap för detta inköp. 12 kolumner är definierade, där de första 9 är obligatoriska, om köparen är en kommun bör kolumn 12, kommun_id, som innehåller kommunkod anges.</p>
<p class="note"><span class="marker">Observation 1</span>Vi väljer att använda beskrivande men korta kolumnnamn som uttrycks med gemener, utan mellanslag (understreck för att separera ord) och utan å, ä och ö.
Orsaken till detta är:
<ol>
  <li>Man vill använda kolumnnamn snarare än ordningen för att detektera om viss data finns. Korta och enkla kolumnnamn minskar risken för att problem uppstår.</li>
  <li>Det är vanligt att man erbjuder söktjänster där frågor mot olika kolumner skrivs in i webbadresser och det är bra om det kan göras utan speciella teckenkodningar.</li>
</ol>
</p>
<p class="note"><span class="marker">Observation 2</span>För en enskild organisation är den första kolumnen (kopare) samma för alla rader. Det kan tyckas onödigt att upprepa detta för varje rad. Alternativet (som valts bort) är att varje mängd inköp måste kompletteras med denna information om datafiler från flera organisationer ska kombineras.</p>
<p class="note"><span class="marker">Observation 3</span>Kolumn 2, faktura_nr, är en förutsättning för att den egna organisationen enkelt kunna göra en automatiserad förfrågan i en e-tjänst om begäran av fakturakopia.</p>
<div class="no-overlarge">
<table class="data">
    <caption>Kolumner i datmodellen</caption>
    <colgroup class="header"></colgroup>
    <colgroup span="3"></colgroup>
    <thead>
    <tr>
        <th>#</th>
        <th>Kolumnnamn</th>
        <th>Värdemängd</th>
        <th>Exempel och förklaring</th>
    </tr>
    </thead>
    <tbody>
    <tr>
        <th>1</th>
        <td>kopare</td>
        <td>organisationsnummer</td>
        <td>Ange organisationsnummer för inköpande organisation [Exempel: "212000-1710" för Skövde kommun.]</td>
    </tr>
    <tr>
        <th>2</th>
        <td>faktura_nr</td>
        <td>heltal eller text</td>
        <td>Ange en unik och stabil identifierare för en faktura, förslagsvis det faktiska fakturanummer som finns i ekonomisystemet. Ibland kallar man det också verifikationsnummer. Undvik mellanslag och andra tecken som inte passar bra i en URI (webbadress).</td>
    </tr>
    <tr>
        <th>3</th>
        <td>leverantor</td>
        <td>text</td>
        <td>Ange namnet på leverantören. Förslagsvis stor bokstav först och sen gemener, men specifika skrivningar av leverantörers namn bör respekteras bara det sker konsekvent.</td>
    </tr>
    <tr>
        <th>4</th>
        <td>leverantor_id</td>
        <td>organisationsnummer</td>
        <td>Ange organisationsnummer för levererande organisation [Exempel: "556036-0793” Saab AB.]</td>
    </tr>
    <tr>
        <th>5</th>
        <td>forvaltning</td>
        <td>text</td>
        <td>Ange namn på förvaltningen som har gjort inköpet. Tex "Ekonomikontoret". Förslagsvis stor bokstav först och sen gemener, men specifika skrivningar av förvaltningens namn bör respekteras bara det sker konsekvent.</td>
    </tr>
    <tr>
        <th>6</th>
        <td>konto_nr</td>
        <td>heltal</td>
        <td>Ange kontonummer där inköpet har bokats enligt den kontoplan som används tex “64310” för facklitteratur.</td>
    </tr>
    <tr>
        <th>7</th>
        <td>konto_text</td>
        <td>text</td>
        <td>Ange texten på konto där inköpet har bokats enligt den kontoplan som används tex “facklitteratur”.</td>
    </tr>
    <tr>
        <th>8</th>
        <td>belopp</td>
        <td>decimaltal</td>
        <td>Ange det belopp utan moms som inköpet avser.</td>
    </tr>
    <tr>
        <th>9</th>
        <td>datum</td>
        <td>datum</td>
        <td>Ange datum när fakturan registreras enligt  “2012-06-14” utan mellanslag.</td>
    </tr>
    <tr>
        <th>10</th>
        <td>grund</td>
        <td>D | R | U | A</td>
        <td>Referens till vilken grund inköpet har gjorts på, antingen Direkt, via Ramavtal, Upphandling eller på Annat sätt.</td>
    </tr>
    <tr>
        <th>11</th>
        <td>avtal</td>
        <td>url</td>
        <td>Länk som identifierar avtal eller lagrum som grund för inköp, använd i första hand webbadresser som inleds med http:// eller https://.</td>
    </tr>
    <tr>
        <th>12</th>
        <td>kommun_id</td>
        <td>text</td>
        <td>Ange <a href="http://www.scb.se/sv_/Hitta-statistik/Regional-statistik-och-kartor/Regionala-indelningar/Lan-och-kommuner/Lan-och-kommuner-i-kodnummerordning/">SCB:s kommunkod för er kommun</a>. Exempel: "0163" för Sollentuna kommun. Observera att en kommunkod måste vara exakt 4 siffror lång, inledande nollor får alltså inte tas bort.
        </td>
    </tr>
    </tbody>
</table>
</div>

<h2 id="csv">2.1 Förtydlingar kring värdemängder</h2>
<p>Alla regular expressions angivna i tabellen nedan (förkortat reg. exp.) förutsätter att de matchar exakt, dvs inga inledande eller eftersläpande tecken tillåts. Det innebär att om uttrycket i tabellen nedan anges som -?\d+ (vilket motsvarar matcha heltal av obegränsad längd, eventuellt med ett minus framför) motsvaras det av det mer kompletta regular expression uttrycket som inleds av /^ och avslutas med $/, dvs /^-?\d+$/. </p>
<div class="no-overlarge">
<table class="data">
    <caption>Kolumner i datmodellen</caption>
    <colgroup class="header"></colgroup>
    <colgroup span="3"></colgroup>
    <thead>
    <tr>
        <th>Värdemängd</th>
        <th>Reg.&nbsp;Exp.</th>
        <th>Exempel och förklaring</th>
    </tr>
    </thead>
    <tbody>
    <tr>
        <th>organisationsnummer</th>
        <td>\d{6}-\d{4}</td>
        <td>Ett organisationsnummer anges med 6+4 siffror med ett bindestreck emellan. Exempelvis: "212000-1710" för Skövde kommun.</td>
    </tr>
    <tr>
        <th>heltal</th>
        <td>-?\d+</td>
        <td>Heltal anges alltid som en radda siffror utan mellanrum eventuellt med ett inledande minus. Se xsd:integer för en längre definition.</td>
    </tr>
    <tr>
        <th>decimaltal</th>
        <td>-?\d+\.\d+</td>
        <td>Decimaltal anges i enlighet med xsd:decimal. Notera att i Sverige används ofta decimalkomma inte punkt. För att vara enhetlig mellan olika dataformat bör decimalpunkt användas istället (på det undviks problem med CSV formatet som använder komma som separator). Den kanoniska representationen i xsd:decimal är påbjuden, dvs inga inledande nollor eller +, samt att man alltid ska ha en siffra innan och efter decimalpunkt. Noll skrivs som 0.0 och ett utelämnat värde tolkas som noll.</td>
    </tr>
    <tr>
        <th>datum</th>
        <td>\d{4]-\d{2}-\d{2}</td>
        <td>Datum skrivs på formatet 2010-01-01 och motsvarar antingen xsd:date. Ingen tid ska anges, inte heller tidszon.</td>
    </tr>
    <tr>
        <th>url</th>
        <td>-</td>
        <td>En URL är en webbadress enligt specifikationen RFC 1738. I detta sammanhang förutsätts schemana http eller https. För webbadresser med speciella tecken tillåts UTF-8 enkodade domäner och pather, se då RFC 3986. Observera att man inte får utelämna schemat, dvs "www.example.com" är inte en tillåten webbadress, däremot är "http://www.example.com" ok. Relativa webbadresser accepteras inte heller.
(En fullständig regular expression utelämnas då den är både för omfattande och opedagogisk.)</td>
    </tr>
    </tbody>
</table>
</div>


<h3 id="accessCSV">3. CSV formatet</h3>
    <p>Det enklaste formatet att stödja är CSV formatet enligt RFC4180. Se exemplet i Appendix A. Det som krävs är att första raden indikerar vilka kolumner som stöds (mellan X och Y stycken):</p>
      <strong class="advisement">kopare,faktura_nr,leverantor,leverantor_id,forvaltning,konto_nr,konto_text,belopp,datum,grund,avtal,kommun_id</strong>
    <p>Utöver det som sägs i RFC4180 krävs alltid att informationen är uttryckt med teckenkodning UTF-8. På grund av att CSV har funnits länge och det finns en uppsjö av olika ramverk och program som inte alla följer RFC4180 så uppmanas man följa devisen:</p>
      <p class="note"><em>"Be conservative in what you do, be liberal in what you accept from others"</em></p>
    <p>För den här specifikationen innebär det att implementatörer rekommenderas även stödja semikolonseparerade filer. Orsaken är att Microsoft Excel använder semikolon istället för komma i CSV filer på operativsystem med svenska som default. Detta på grund av att komma används för decimaltal vilket ofta förekommer i CSV-filer vilket skulle kräva en omfattande användning av dubbla citationstecken kring värden. Denna specifikation kräver dock att man använder punkt i decimaltal (se 2.1).</p>
<p>För att särskilja data som är semikolonseparerade från kommaseparerade måste första raden se ut som:</p>
<strong class="advisement">kopare,faktura_nr,leverantor,leverantor_id,forvaltning,konto_nr,konto_text,belopp,datum,grund,avtal,kommun_id</strong>
<h3 id="accessHTTP">3.2 Åtkomst via HTTP</h3>
<p>Om data görs tillgängligt på en webbadress bör följande gälla:</p>
    <ul>
        <li>Content-type ska vara text/csv (även för data med semikolonseparerade värden)</li>
        <li>Last-modified bör ange när datat senast ändrats</li>
        <li>HEAD requests bör stödjas där Last-modified ingår</li>
    </ul>

<h3 id="schemaCSV">3.2 Schema</h3>
<p>Du som är nöjd med att leverera eller använda data utifrån vad som beskrivs skriftligen i denna specifikation och exemplifieras i appendixen kan ignorera detta avsnitt.</p>
<p>Sedan 2015 finns, <a href="https://www.w3.org/TR/tabular-metadata/">"Metadata Vocabulary for
    Tabular Data"</a>, en W3C rekommendation för hur man anger metadata för datamodeller uttryckta i CSV.</p>
<strong class="advisement">Schema: <a href="https://lankadedata.se/spec/leverantorsreskontra/schema.json">https://lankadedata.se/spec/leverantorsreskontra/schema.json</a></strong>
<p>För detta fall innebär detta schema:</p>
<ul>
    <li>maskinell verifiering att CSV-uttryck är korrekta</li>
    <li>länka ihop med andra datakällor</li>
    <li>konvertera data till länkade data</li>
</ul>
<p>De två sistnämnda kommer sig av att schemat också tillhandahåller saknad information,
  bland annat hur man konverterar ett visst CSV uttryck till RDF.
  Mer specifikt innehåller metadatan hur rader konverteras till instanser av .
    till instanser av <a href="https://schema.org/">schema.orgs</a> <a href="https://schema.org/Invoice">Invoice</a>.</p>
<p>Valet av schema.org gjordes eftersom den tillhandahåller en mängd egenskaper som till stor del täcker in
    skolinformationen. För den som är intresserad går det att hitta andra representationer av skolor som
    RDF/länkade data.</p>

<h2 id="json">4. JSON formatet</h2>
<p>JSON uttrycket följer direkt ifrån CSV schemat och
    <a href="https://www.w3.org/TR/csv2json/">W3C rekommendationen "Generating JSON from Tabular Data on the Web"</a>
    . Se exempel i <a href="#exampleJSON">appendix B</a>.</p>

<h3 id="accessJSON">4.1 Åtkomst via HTTP</h3>
<p>Samma gäller som <a href="#accessCSV">för CSV</a> förutom att content-type ska vara "application/json".</p>

<h3 id="schemaJSON">4.2 Schema</h3>
<p>Indirekt via <a href="#schemaCSV">CSV schemat</a>.</p>

<h2 id="dcat">5. Beskrivning i datakatalog</h2>
<p>För den som vill lägga in sin data som en datamängd i en datakatalog ska man använda sig av <a href="https://www.w3.org/TR/vocab-dcat/">W3C
    rekommendationen DCAT</a>. För
    svenska behov är det <a href="https://lankadedata.se/spec/DCAT-AP-SE/">DCAT-AP-SE</a> som gäller. För att göra det enklare att hitta alla datamängder som följer specifikationen på t.ex. <a
            href="https://dataportal.se">dataportal.se</a> är det viktigt att man markerar dessa datamängder. Man bör
    då göra följande:</p>
<ol>
    <li>På datamängden peka ut denna specifikation via propertyn dcterms:conformsTo (med fältnamnet "uppfyller").</li>
    <li>Lägg till "leverantörsreskontra", "inköp" som nyckelord på svenska.</li>
    <li>På distributionen som motsvarar CSV filen peka ut schemat via propertyn dcterms:conformsTo (med fältnamnet "länkade
        scheman").</li>
</ol>
<!-- Här läggs ett exempel med leverantörsreskontradata uttryckt i en DCAT-datakatalog
<pre class="example">
<span class="marker">Exempel: Datamängd med leverantörsreskontradata uttryckt i en DCAT katalog</span>
&lt;dcat:Catalog>
    &lt;dct:title>En datakatalog&lt;/dct:title>
    &lt;dcat:dataset rdf:resource="http://example.com/dataset1"/>
&lt;/dcat:Catalog>
&lt;dcat:Dataset rdf:about="http://example.com/dataset1">
    &lt;dct:title>En leverantörsreskontradatamängd&lt;/dct:title>
    &lt;dcat:keyword xml:lang="sv">levreskontradata&lt;/dcat:keyword>
    &lt;dct:conformsTo rdf:resource="https://lankadedata.se/spec/leverantorsreskontra/"/>
    &lt;dcat:distribution rdf:resource="http://example.com/distribution1"/>
&lt;/dcat:Dataset>
&lt;dcat:Distribution rdf:about="http://example.com/distribution1">
    &lt;dct:title>Leverantörsreskontra som CSV&lt;/dct:title>
    &lt;dcat:downloadURL rdf:resource="http://example.com/levreskontrafil.csv"/>
    &lt;dcat:accessURL rdf:resource="http://example.com/levreskontrafil.csv"/>
    &lt;dct:format>text/csv&lt;/dct:format>
    &lt;dct:conformsTo rdf:resource="https://lankadedata.se/spec/leverantorsreskontra/schema.json"/>
&lt;/dcat:Distribution>
</pre>-->
<h2 id="exampleCSV">Appendix A: Exempel på inköp i CSV</h2>
<pre class="example">
<span class="marker">Exempel: Nedan är en fil med två riktiga inköp från Göteborg stad, fälten grund och avtal innehåller påhittade värden dock.</span>
kopare,faktura_nr,leverantor,leverantor_id,forvaltning,konto_nr,konto_text,belopp,datum,grund,avtal,kommun_id
212000-1355,3921217387,Jordbruksverket distriktsveterinärerna,202100-4151,392 - Park- och Naturnämnden,7459,övriga konsulttjänster,2022.31,2020-01-01,A,http://example.com/avtal1,1480
212000-1355,8001020462,Folkhälsomyndigheten,202100-6545,800 - Miljö- och klimatnämnden,7499,Övriga främmande tjänster,444.75,2020-01-01,A,http://example.com/avtal2,1480
</pre>

<h2 id="exampleJSON">Appendix B: Exempel på inköp i JSON</h2>
<pre class="example">
<span class="marker">Exempel: Samma två inköp som för CSV fast nu i json.</span>
[
  {
    "kopare": "212000-1355",
    "faktura_nr": "3921217387",
    "leverantor": "Jordbruksverket distriktsveterinärerna",
    "leverantor_id": "202100-4151",
    "forvaltning": "392 - Park- och Naturnämnden",
    "konto_nr": "7459",
    "konto_text": "övriga konsulttjänster",
    "belopp": "2022.31",
    "datum": "2020-01-01",
    "grund": "A",
    "avtal": "http://example.com/avtal1.html",
    "kommun_id": "1480"
  },
  {
    "kopare": "212000-1355",
    "faktura_nr": "8001020462",
    "leverantor": "Folkhälsomyndigheten",
    "leverantor_id": "202100-6545",
    "forvaltning": "800 - Miljö- och klimatnämnden",
    "konto_nr": "7499",
    "konto_text": "Övriga främmande tjänster",
    "belopp": "444.75",
    "datum": "2020-01-01",
    "grund": "A",
    "avtal": "http://example.com/avtal2.html",
    "kommun_id": "1480"
  }
]
</pre>
<h2 id="versions">Appendix C: Versionshistorik</h2>

<ul class="versions">
    <li>2020-10-09 - Första publicerade stabila versionen
        <ul>
            <li>Överflytt till HTML</li>
            <li>Inkluderade ändringar efter granskning</li>
            <li>Stabil adress på lankadedata.se</li>
            <li>Version 1.0</li>
        </ul>
    </li>
    <li>2020-06-05 - Ny version
        <ul>
            <li>Genomgång av ett fåtal externa granskare</li>
            <li>Uppdaterad datamodell & scheman</li>
            <li>Appendix A, B skrivna</li>
        </ul>
    </li>
    <li>2019-09-05 - Utkast till första version
        <ul>
            <li>Genomgång av befintliga publiceringar från Örebro, Lidingö och Göteborg.</li>
            <li>Definiera referenser allmängiltiga för Kommuner och Myndigheter.</li>
            <li>Sammanfattande kapitel om CSV formatet.</li>
        </ul>
    </li>
</ul>
</body>
<script src="fixup.js"></script>
</html>
